struct Solution;


impl Solution {
    pub fn majority_element(nums: Vec<i32>) -> i32 {
        let mut candidate = nums[0];
        let mut count = 0;
        for n in nums {
            if count == 0 {
                candidate = n;
            }
            if n == candidate {
                count += 1;
            } else {
                count -= 1;
            }
        }

        candidate
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_majority_element() {
        let nums = vec![2,2,1,1,1,2,2];
        let res = Solution::majority_element(nums);
        assert_eq!(res, 2);
    }
}